# Database Normalisation

- Important process in database design that improves a database's efficiency, consistency and accuracy
- It is the process of organising the attributes of the database to reduce or eliminate data redundancy
- Data redundancy increases the site of the database as the same data is repeated in many places
- Inconsistency problems also arise during insert, delete and update operations.
- In the relational model, there are standard methods to quantify a database's efficiency.
	- These are called `Normal Forms`
- The primary objective for normalising the relations is to eliminate the below anomalies.
	- Failure to do so results in data redundancy, which may threaten data integrity.

## Database Anomalies

Insertion Anomalies
: These occur when it is not possible to insert data into a database due to missing fields or incomplete data
: For example; if a database requires every record to have a primary key, but no value is provided for a particular record, then it cannot be inserted into a database.
Deletion Anomalies
: These occur when deleting a record from a database and can result in unintentional loss of data.
: For example; if a database contains information about customers and orders, deleting a customer record may also delete all the orders associated with that customer.
Update Anomalies
: These occur when modifying data in a database and can result in inconsistencies and errors.
: For example; if a database contains information about employees and their salaries, updaying an employee's salary in one record but not in all related records could lead to incorrect calculations and reporting.

## Prerequisites for Database Normalisation

- In database normalisation, we only put tightly related information together.
- To find the closeness, we need to find which attributes depend on each other.

Keys
: TODO

Functional Dependency
: TODO

Dependency Preserving Decomposition
: TODO

Lossless Decomposition in Database Management Systems
: TODO

## Features of Database Normalisation

Elimination of Data Redundancy
: TODO

Ensuring Data Consistency
: TODO

Simplification of Data Management
: TODO

Avoiding Update Anomalies
: TODO

Standardisation
: TODO

## Normal Forms in Database Management Systems

First Normal Form (1NF)
: A relation is in first normal form if every attribute in that relation is single-valued.

Second Normal Form (2NF)
: A relation that is in 1NF and every non-primary key attribute is fully funtionally dependent on the primary key.

Third Normal Form (3NF)
: A relation that has no transitive dependency for non-prime attributes as well as being in 2NF.
: A relation is in 3NF if at least one of the following conditions holds in every non-trivial functional dependency X -> Y
	: X is a super key
	: Y is a prime attribute (each element of Y is part of some candidate key)

Boyce-Codd Normal Form (BCNF)
: The relation should be in 3NF
: X should be a super-key for every functional dependency (FD) X -> Y in a given relation

Fourth Normal Form (4NF) 
: The relation should be in BCNF
: The table should nothave any multi-valued dependency

Fifth Normal Form (5NF)
: The relation should be in 4NF
: It cannot be further non-loss decomposed (join dependency)

## Links

- https://www.geeksforgeeks.org/introduction-of-database-normalization/
- https://www.geeksforgeeks.org/first-normal-form-1nf/
- https://www.geeksforgeeks.org/data-base-dependency-preserving-decomposition/
- https://www.geeksforgeeks.org/lossless-decomposition-in-dbms/
